Index: trunk/zoo-kernel/service_internal.c
===================================================================
--- trunk/zoo-kernel/service_internal.c	(revision 8)
+++ trunk/zoo-kernel/service_internal.c	(revision 9)
@@ -1181,323 +563,38 @@
 	nc4 = xmlNewNode(NULL, BAD_CAST "UOMs");
 	nc5 = xmlNewNode(NULL, BAD_CAST "Default");
+	datatype=1;
       }
       tmp1=_tmp->content;
+      int default1=0;
+      xmlNodePtr nc7;
       while(tmp1!=NULL){
 #ifdef DEBUG
 	printf("DATATYPE DEFAULT ? %s\n",tmp1->name);
 #endif
-	if(strcmp(tmp1->name,"DataType")==0){
-	  nc6 = xmlNewNode(ns_ows, BAD_CAST tmp1->name);
+	if(strncasecmp(tmp1->name,"DataType",8)==0){
+	  nc6 = xmlNewNode(ns_ows, BAD_CAST "DataType");
 	  xmlAddChild(nc6,xmlNewText(BAD_CAST tmp1->value));
 	  char tmp[1024];
 	  sprintf(tmp,"http://www.w3.org/TR/xmlschema-2/#%s",tmp1->value);
-	  xmlNewProp(nc6,BAD_CAST "ows:reference",BAD_CAST tmp);
+	  xmlNewNsProp(nc6,ns_ows,BAD_CAST "reference",BAD_CAST tmp);
 	  xmlAddChild(nc3,nc6);
 	  tmp1=tmp1->next;
 	  continue;
 	}
-	if(strcmp(tmp1->name,"asReference")!=0 && 
-	   strcmp(tmp1->name,"DataType")!=0 && 
-	   strcmp(tmp1->name,"value")!=0){
-	  nc6 = xmlNewNode(ns_ows, BAD_CAST tmp1->name);
-	  xmlAddChild(nc6,xmlNewText(BAD_CAST tmp1->value));
-	  xmlAddChild(nc5,nc6);
-	}
-	else{
-	  if(strcmp(tmp1->name,"value")==0){
-	    nc6 = xmlNewNode(NULL, BAD_CAST "DefaultValue");
-	    xmlAddChild(nc6,xmlNewText(BAD_CAST tmp1->value));
-	    xmlAddChild(nc3,nc6);
+	if(strcasecmp(tmp1->name,"asReference")!=0 && 
+	   strcasecmp(tmp1->name,"DataType")!=0 && 
+	   strncasecmp(tmp1->name,"AllowedValues",13)!=0 &&
+	   strcasecmp(tmp1->name,"value")!=0 &&
+	   strcasecmp(tmp1->name,"extension")!=0){
+	  if(datatype==0){
+	    char *tmp2=zCapitalize1(tmp1->name);
+	    nc6 = xmlNewNode(NULL, BAD_CAST tmp2);
+	    free(tmp2);
 	  }
-	}
-	tmp1=tmp1->next;
-      }
-      xmlAddChild(nc4,nc5);
-      xmlAddChild(nc3,nc4);
-    }
-    xmlAddChild(nc2,nc3);
-    
-    _tmp=e->supported;
-    if(_tmp!=NULL){
-      if(strcmp(e->format,"LiteralData")!=0){
-	nc4 = xmlNewNode(NULL, BAD_CAST "Supported");
-	nc5 = xmlNewNode(NULL, BAD_CAST "Format");
-      }
-      else{
-	nc5 = xmlNewNode(NULL, BAD_CAST "Supported");
-	
-      }
-      tmp1=_tmp->content;
-      while(tmp1!=NULL){
-	/*if(strcmp(e->format,"LiteralData")==0)
-	  xmlAddChild(nc5,nc6);*/
-	nc6 = xmlNewNode(ns_ows, BAD_CAST tmp1->name);
-	xmlAddChild(nc6,xmlNewText(BAD_CAST tmp1->value));
-	xmlAddChild(nc5,nc6);
-	tmp1=tmp1->next;
-      }
-      xmlAddChild(nc4,nc5);
-      if(strcmp(e->format,"LiteralData")!=0){
-	xmlAddChild(nc3,nc4);
-      }
-    }
-    if(strcmp(e->format,"LiteralData")!=0){
-      xmlAddChild(nc2,nc3);
-    }
-    xmlAddChild(nc1,nc2);
-    
-    
-    e=e->next;
-  }
-  xmlAddChild(nc,nc1);
-
-  nc1 = xmlNewNode(NULL, BAD_CAST "ProcessOutputs");
-  
-  e=serv->outputs;
-  while(e!=NULL){
-    nc2 = xmlNewNode(NULL, BAD_CAST "Output");
-    tmp1=getMap(e->content,"minOccurs");
-    if(tmp1){
-      xmlNewProp(nc2,BAD_CAST tmp1->name,BAD_CAST tmp1->value);
-    }
-    tmp1=getMap(e->content,"maxOccurs");
-    if(tmp1){
-      xmlNewProp(nc2,BAD_CAST tmp1->name,BAD_CAST tmp1->value);
-    }
-
-    printDescription(nc2,ns_ows,e->name,e->content);
-
-    nc3 = xmlNewNode(ns, BAD_CAST e->format);
-    fprintf(stderr,"LITERALDATA ? %s",e->format);
-    iotype* _tmp=e->defaults;
-    if(_tmp!=NULL){
-      if(strcmp(e->format,"LiteralData")!=0 &&
-	 strcmp(e->format,"LiteralOutput")!=0){
-	nc4 = xmlNewNode(NULL, BAD_CAST "Default");
-	nc5 = xmlNewNode(NULL, BAD_CAST "Format");
-      }   
-      else{
-	nc4 = xmlNewNode(NULL, BAD_CAST "UOMs");
-	nc5 = xmlNewNode(NULL, BAD_CAST "Default");
-      }
-
-      /*nc4 = xmlNewNode(NULL, BAD_CAST "Default");
-	nc5 = xmlNewNode(NULL, BAD_CAST "Format");
-      */
-      tmp1=_tmp->content;
-      while(tmp1!=NULL){
-#ifdef DEBUG
-	printf("DATATYPE DEFAULT ? %s\n",tmp1->name);
-	fprintf(stderr,"DEBUG DATATYPE !!\n");
-	dumpMap(tmp1);
-#endif
-	if(strcmp(tmp1->name,"DataType")==0){
-	  nc6 = xmlNewNode(ns_ows, BAD_CAST tmp1->name);
-	  xmlAddChild(nc6,xmlNewText(BAD_CAST tmp1->value));
-	  char tmp[1024];
-	  sprintf(tmp,"http://www.w3.org/TR/xmlschema-2/#%s",tmp1->value);
-	  xmlNewProp(nc6,BAD_CAST "ows:reference",BAD_CAST tmp);
-	  xmlAddChild(nc5,nc6);
-	  tmp1=tmp1->next;
-	  continue;
-	}
-	if(strcmp(tmp1->name,"asReference")!=0 && strcmp(tmp1->name,"DataType")!=0){
-	  nc6 = xmlNewNode(ns_ows, BAD_CAST tmp1->name);
-	  xmlAddChild(nc6,xmlNewText(BAD_CAST tmp1->value));
-	  xmlAddChild(nc5,nc6);
-	}
-	tmp1=tmp1->next;
-      }
-      xmlAddChild(nc4,nc5);
-      xmlAddChild(nc3,nc4);	    
-    }
-    _tmp=e->supported;
-    while(_tmp!=NULL){
-      nc4 = xmlNewNode(NULL, BAD_CAST "Supported");
-      nc5 = xmlNewNode(NULL, BAD_CAST "Format");
-      tmp1=_tmp->content;
-      while(tmp1!=NULL){
-#ifdef DEBUG
-	printf("DATATYPE SUPPORTED ? %s\n",tmp1->name);
-#endif
-	if(strcmp(tmp1->name,"asReference")!=0 && strcmp(tmp1->name,"DataType")!=0){
-	  nc6 = xmlNewNode(ns_ows, BAD_CAST tmp1->name);
-	  xmlAddChild(nc6,xmlNewText(BAD_CAST tmp1->value));
-	  xmlAddChild(nc5,nc6);
-	}
-	tmp1=tmp1->next;
-      }
-      _tmp=_tmp->next;
-      xmlAddChild(nc4,nc5);
-      xmlAddChild(nc3,nc4);
-    }
-    xmlAddChild(nc2,nc3);
-
-    xmlAddChild(nc3,nc4);
-      
-    
-    xmlAddChild(nc2,nc3);
-    
-    xmlAddChild(nc1,nc2);
-    
-    e=e->next;
-  }
-  xmlAddChild(nc,nc1);
-
-  xmlAddChild(n,nc);
-
-  xmlDocSetRootElement(doc, n);
-    
-  /*
-   * Dump the document to a buffer and print it
-   * for demonstration purposes.
-   */
-  xmlDocDumpFormatMemory(doc, &xmlbuff, &buffersize, 1);
-  printf((char *) xmlbuff);
-  
-  /*
-   * Free associated memory.
-   */
-  xmlFree(xmlbuff);
-  //xmlFreeDoc(doc);
-
-}
-
-xmlNodePtr printDescribeProcessHeader(xmlDocPtr doc,char* service,maps* m){
-
-  xmlNsPtr ns,ns_ows,ns_xlink,ns_xsi;
-  //xmlDocPtr doc;
-  xmlNodePtr n,nr;
-  xmlChar *xmlbuff;
-  int buffersize;
-  /**
-   * Create the document and its temporary root.
-   */
-  nr = xmlNewNode(ns, BAD_CAST "root");
-  ns=xmlNewNs(nr,BAD_CAST "http://schemas.opengis.net/wps/1.0.0",BAD_CAST "wps");
-
-  /*doc = xmlNewDoc(BAD_CAST "1.0");
-    doc->encoding = xmlCharStrdup ("UTF-8");*/
-
-  n = xmlNewNode(ns, BAD_CAST "ProcessDescriptions");  
-  ns_ows=xmlNewNs(n,BAD_CAST "http://www.opengis.net/ows/1.1",BAD_CAST "ows");
-  xmlNewNs(n,BAD_CAST "http://www.opengis.net/wps/1.0.0",BAD_CAST "wps");
-  xmlNewNs(n,BAD_CAST "http://www.w3.org/1999/xlink",BAD_CAST "xlink");
-  xmlNewNs(n,BAD_CAST "http://www.w3.org/2001/XMLSchema-instance",BAD_CAST "xsi");
-  xmlNewProp(n,BAD_CAST "xsi:schemaLocation",BAD_CAST "http://www.opengis.net/wps/1.0.0 http://schemas.opengis.net/wps/1.0.0/wpsDescribeProcess_response.xsd");
-  xmlNewProp(n,BAD_CAST "service",BAD_CAST "WPS");
-  xmlNewProp(n,BAD_CAST "version",BAD_CAST "1.0.0");
-  xmlNewProp(n,BAD_CAST "xml:lang",BAD_CAST "en");
-
-  xmlDocSetRootElement(doc, n);
-
-  return n;
-}
-
-void printDescribeProcessForProcess(maps* m,xmlNodePtr nc,service** serv,int sc){
-  xmlNsPtr ns,ns_ows,ns_xlink,ns_xsi;
-  xmlNodePtr nr,n,nc1,nc2,nc3,nc4,nc5,nc6,pseudor;
-
-  char tmp[256];
-  n=nc;
-  nr = xmlNewNode(ns, BAD_CAST "root");
-  
-  ns=xmlNewNs(nr,BAD_CAST "http://www.opengis.net/wps/1.0.0",BAD_CAST "wps");
-  ns_ows=xmlNewNs(nr,BAD_CAST "http://www.opengis.net/ows/1.1.0",BAD_CAST "ows");
-
-  nc = xmlNewNode(NULL, BAD_CAST "ProcessDescription");
-  char *tmp4[3];
-  tmp4[0]="processVersion";
-  tmp4[1]="storeSupported";
-  tmp4[2]="statusSupported";
-  int j=0;
-  map* tmp1=NULL;
-  for(j=0;j<3;j++){
-    tmp1=getMap(serv[0]->content,tmp4[j]);
-    if(tmp1!=NULL){
-      if(j==0)
-	xmlNewProp(nc,BAD_CAST "wps:processVersion",BAD_CAST tmp1->value);      
-      else
-	xmlNewProp(nc,BAD_CAST tmp4[j],BAD_CAST tmp1->value);      
-    }
-    else{
-      if(j>0)
-	xmlNewProp(nc,BAD_CAST tmp4[j],BAD_CAST "false");      
-    }
-  }
-  
-  printDescription(nc,ns_ows,serv[0]->name,serv[0]->content);
-
-  tmp1=serv[0]->metadata;
-  while(tmp1!=NULL){
-    nc1 = xmlNewNode(ns_ows, BAD_CAST "Metadata");
-    char toto[1024];
-    sprintf(toto,"xlink:%s",tmp1->name);
-    xmlNewProp(nc1,BAD_CAST toto,BAD_CAST tmp1->value);
-    xmlAddChild(nc,nc1);
-    tmp1=tmp1->next;
-  }
-
-  tmp1=getMap(serv[0]->content,"Profile");
-  if(tmp1!=NULL){
-    nc1 = xmlNewNode(ns, BAD_CAST "Profile");
-    xmlAddChild(nc1,xmlNewText(BAD_CAST tmp1->value));
-    xmlAddChild(nc,nc1);
-  }
-
-  nc1 = xmlNewNode(NULL, BAD_CAST "DataInputs");
-  
-  elements* e=serv[0]->inputs;
-  while(e!=NULL){
-    nc2 = xmlNewNode(NULL, BAD_CAST "Input");
-    tmp1=getMap(e->content,"minOccurs");
-    if(tmp1){
-      xmlNewProp(nc2,BAD_CAST tmp1->name,BAD_CAST tmp1->value);
-    }
-    tmp1=getMap(e->content,"maxOccurs");
-    if(tmp1){
-      xmlNewProp(nc2,BAD_CAST tmp1->name,BAD_CAST tmp1->value);
-    }
-
-    printDescription(nc2,ns_ows,e->name,e->content);
-
-
-    nc3 = xmlNewNode(NULL, BAD_CAST e->format);
-    iotype* _tmp=e->defaults;
-    int datatype=0;
-    if(_tmp!=NULL){
-      if(strcmp(e->format,"LiteralData")!=0){
-	nc4 = xmlNewNode(NULL, BAD_CAST "Default");
-	nc5 = xmlNewNode(NULL, BAD_CAST "Format");
-      }
-      else{
-	nc4 = xmlNewNode(NULL, BAD_CAST "UOMs");
-	nc5 = xmlNewNode(NULL, BAD_CAST "Default");
-	datatype=1;
-      }
-      tmp1=_tmp->content;
-      int default1=0;
-      xmlNodePtr nc7;
-      while(tmp1!=NULL){
-#ifdef DEBUG
-	printf("DATATYPE DEFAULT ? %s\n",tmp1->name);
-#endif
-	if(strcmp(tmp1->name,"DataType")==0){
-	  nc6 = xmlNewNode(ns_ows, BAD_CAST tmp1->name);
-	  xmlAddChild(nc6,xmlNewText(BAD_CAST tmp1->value));
-	  char tmp[1024];
-	  sprintf(tmp,"http://www.w3.org/TR/xmlschema-2/#%s",tmp1->value);
-	  xmlNewProp(nc6,BAD_CAST "ows:reference",BAD_CAST tmp);
-	  xmlAddChild(nc3,nc6);
-	  tmp1=tmp1->next;
-	  continue;
-	}
-	if(strcmp(tmp1->name,"asReference")!=0 && 
-	   strcmp(tmp1->name,"DataType")!=0 && 
-	   strcmp(tmp1->name,"value")!=0){
-	  if(datatype==0)
-	  nc6 = xmlNewNode(NULL, BAD_CAST tmp1->name);
-	  else
-	  nc6 = xmlNewNode(ns_ows, BAD_CAST tmp1->name);
+	  else{
+	    char *tmp2=zCapitalize(tmp1->name);
+	    nc6 = xmlNewNode(ns_ows, BAD_CAST tmp2);
+	    free(tmp2);
+	  }
 	  xmlAddChild(nc6,xmlNewText(BAD_CAST tmp1->value));
 	  xmlAddChild(nc5,nc6);
@@ -1509,4 +606,20 @@
 	    default1=1;
 	  }
+	  if(strncasecmp(tmp1->name,"AllowedValues",13)==0){
+	    nc6 = xmlNewNode(ns_ows, BAD_CAST "AllowedValues");
+	    char *token,*saveptr1;
+	    token=strtok_r(tmp1->value,",",&saveptr1);
+	    while(token!=NULL){
+	   	nc7 = xmlNewNode(ns_ows, BAD_CAST "Value");
+		char *tmps=strdup(token);
+		tmps[strlen(tmps)]=0;
+		xmlAddChild(nc7,xmlNewText(BAD_CAST tmps));
+		fprintf(stderr,"strgin : %s\n",tmps);
+		xmlAddChild(nc6,nc7);
+		token=strtok_r(NULL,",",&saveptr1);
+	    }
+	    xmlAddChild(nc3,nc6);
+	    isAnyValue=-1;
+	  }
 	}
 	tmp1=tmp1->next;
@@ -1514,14 +627,16 @@
       xmlAddChild(nc4,nc5);
       xmlAddChild(nc3,nc4);
-      if(datatype==1){
-		xmlAddChild(nc3,xmlNewNode(ns_ows, BAD_CAST "AnyValue"));
-		if(default1>0)
-	    xmlAddChild(nc3,nc7);
-      }
+      if(datatype==1 && isAnyValue==1){
+	xmlAddChild(nc3,xmlNewNode(ns_ows, BAD_CAST "AnyValue"));
+	if(default1>0)
+	  xmlAddChild(nc3,nc7);
+      }
+      if(datatype==1 && default1>0)
+      	xmlAddChild(nc3,nc7);
     }
     xmlAddChild(nc2,nc3);
     
     _tmp=e->supported;
-    if(_tmp!=NULL){
+    while(_tmp!=NULL){
       if(datatype==0){
 	nc4 = xmlNewNode(NULL, BAD_CAST "Supported");
@@ -1535,8 +650,14 @@
 	/*if(strcmp(e->format,"LiteralData")==0)
 	  xmlAddChild(nc5,nc6);*/
-	if(datatype==0)
-	nc6 = xmlNewNode(NULL, BAD_CAST tmp1->name);
-	else
-	nc6 = xmlNewNode(ns_ows, BAD_CAST tmp1->name);
+	if(datatype==0){
+	  char *tmp2=zCapitalize1(tmp1->name);
+	  nc6 = xmlNewNode(NULL, BAD_CAST tmp2);
+	  free(tmp2);
+	}
+	else{
+	  char *tmp2=zCapitalize(tmp1->name);	  
+	  nc6 = xmlNewNode(ns_ows, BAD_CAST tmp2);
+	  free(tmp2);
+	}
 	xmlAddChild(nc6,xmlNewText(BAD_CAST tmp1->value));
 	xmlAddChild(nc5,nc6);
@@ -1549,10 +670,11 @@
       	xmlAddChild(nc4,nc5);
 	//xmlAddChild(nc3,xmlNewNode(ns_ows, BAD_CAST "AnyValue"));
-	}
-    }
-    if(strcmp(e->format,"LiteralData")!=0){
-      xmlAddChild(nc2,nc3);
-    }
-    xmlAddChild(nc1,nc2);
+      }
+      _tmp=_tmp->next;
+      if(strcmp(e->format,"LiteralData")!=0){
+	xmlAddChild(nc2,nc3);
+      }
+      xmlAddChild(nc1,nc2);
+    }
     
     
@@ -1563,5 +685,5 @@
   nc1 = xmlNewNode(NULL, BAD_CAST "ProcessOutputs");
   
-  e=serv[0]->outputs;
+  e=serv->outputs;
   while(e!=NULL){
     nc2 = xmlNewNode(NULL, BAD_CAST "Output");
@@ -1577,8 +699,8 @@
     printDescription(nc2,ns_ows,e->name,e->content);
 
-    if(strcmp(mtoupper(e->format),"LITERALDATA")==0)
+    if(strncasecmp(e->format,"LITERALDATA",strlen(e->format))==0)
       nc3 = xmlNewNode(NULL, BAD_CAST "LiteralOutput");
     else
-      if(strcmp(mtoupper(e->format),"COMPLEXDATA")==0)
+      if(strncasecmp(e->format,"COMPLEXDATA",strlen(e->format))==0)
 	nc3 = xmlNewNode(NULL, BAD_CAST "ComplexOutput");
       else
@@ -1594,6 +716,6 @@
      }
       else{
-      nc4 = xmlNewNode(NULL, BAD_CAST "Default");
-      nc5 = xmlNewNode(NULL, BAD_CAST "Format");
+	nc4 = xmlNewNode(NULL, BAD_CAST "Default");
+	nc5 = xmlNewNode(NULL, BAD_CAST "Format");
       }
       tmp1=_tmp->content;
@@ -1602,10 +724,10 @@
 	printf("DATATYPE DEFAULT ? %s\n",tmp1->name);
 #endif
-	if(strcmp(tmp1->name,"DataType")==0){
-	  nc6 = xmlNewNode(ns_ows, BAD_CAST tmp1->name);
+	if(strncasecmp(tmp1->name,"DataType",8)==0){
+	  nc6 = xmlNewNode(ns_ows, BAD_CAST "DataType");
 	  xmlAddChild(nc6,xmlNewText(BAD_CAST tmp1->value));
 	  char tmp[1024];
 	  sprintf(tmp,"http://www.w3.org/TR/xmlschema-2/#%s",tmp1->value);
-	  xmlNewProp(nc6,BAD_CAST "ows:reference",BAD_CAST tmp);
+	  xmlNewNsProp(nc6,ns_xlink,BAD_CAST "reference",BAD_CAST tmp);
 	  xmlAddChild(nc3,nc6);
 	  tmp1=tmp1->next;
@@ -1613,9 +735,17 @@
 	  continue;
 	}
-	if(strcmp(tmp1->name,"asReference")!=0 && strcmp(tmp1->name,"DataType")!=0){
-	  if(datatype==0)
-	  nc6 = xmlNewNode(NULL, BAD_CAST tmp1->name);
-	  else
-	  nc6 = xmlNewNode(ns_ows, BAD_CAST tmp1->name);
+	if(strcmp(tmp1->name,"asReference")!=0 &&
+	   strncasecmp(tmp1->name,"DataType",8)!=0 &&
+	   strcasecmp(tmp1->name,"extension")!=0){
+	  if(datatype==0){
+	    char *tmp2=zCapitalize1(tmp1->name);
+	    nc6 = xmlNewNode(NULL, BAD_CAST tmp2);
+	    free(tmp2);
+	  }
+	  else{
+	    char *tmp2=zCapitalize(tmp1->name);
+	    nc6 = xmlNewNode(ns_ows, BAD_CAST tmp2);
+	    free(tmp2);
+	  }
 	  xmlAddChild(nc6,xmlNewText(BAD_CAST tmp1->value));
 	  xmlAddChild(nc5,nc6);
@@ -1639,9 +769,17 @@
 	printf("DATATYPE SUPPORTED ? %s\n",tmp1->name);
 #endif
-	if(strcmp(tmp1->name,"asReference")!=0 && strcmp(tmp1->name,"DataType")!=0){
-	  if(datatype==0)
-	  nc6 = xmlNewNode(NULL, BAD_CAST tmp1->name);
-	  else
-	  nc6 = xmlNewNode(ns_ows, BAD_CAST tmp1->name);
+	if(strcmp(tmp1->name,"asReference")!=0 && 
+	   strcmp(tmp1->name,"DataType")!=0 &&
+	   strcasecmp(tmp1->name,"extension")!=0){
+	  if(datatype==0){
+	    char *tmp2=zCapitalize1(tmp1->name);
+	    nc6 = xmlNewNode(NULL, BAD_CAST tmp2);
+	    free(tmp2);
+	  }
+	  else{
+	    char *tmp2=zCapitalize(tmp1->name);
+	    nc6 = xmlNewNode(ns_ows, BAD_CAST tmp2);
+	    free(tmp2);
+	  }
 	  xmlAddChild(nc6,xmlNewText(BAD_CAST tmp1->value));
 	  xmlAddChild(nc5,nc6);
@@ -1673,22 +811,187 @@
 }
 
-void printDescribeProcessDocument(xmlDocPtr doc){
+void printProcessResponse(maps* m,map* request, int pid,service* serv,char* service,int status,maps* inputs,maps* outputs){
+  xmlNsPtr ns,ns_ows,ns_xlink,ns_xsi;
+  xmlNodePtr nr,n,nc,nc1,nc2,nc3,pseudor;
+  xmlDocPtr doc;
+  xmlChar *xmlbuff;
+  int buffersize;
+  time_t time1;  
+  time(&time1);
+  /**
+   * Create the document and its temporary root.
+   */
+  doc = xmlNewDoc(BAD_CAST "1.0");
+  int wpsId=zooXmlAddNs(NULL,"http://www.opengis.net/wps/1.0.0","wps");
+  ns=usedNs[wpsId];
+  
+  n = xmlNewNode(ns, BAD_CAST "ExecuteResponse");
+  int owsId=zooXmlAddNs(n,"http://www.opengis.net/ows/1.1","ows");
+  ns_ows=usedNs[owsId];
+  int xlinkId=zooXmlAddNs(n,"http://www.w3.org/1999/xlink","xlink");
+  ns_xlink=usedNs[xlinkId];
+  int xsiId=zooXmlAddNs(n,"http://www.w3.org/2001/XMLSchema-instance","xsi");
+  ns_xsi=usedNs[xsiId];
+  xmlNewNs(n,BAD_CAST "http://www.opengis.net/wps/1.0.0",BAD_CAST "wps");
+
+  xmlNewNsProp(n,ns_xsi,BAD_CAST "schemaLocation",BAD_CAST "http://www.opengis.net/wps/1.0.0 http://schemas.opengis.net/wps/1.0.0/wpsExecute_response.xsd");
+  
+  xmlNewProp(n,BAD_CAST "service",BAD_CAST "WPS");
+  xmlNewProp(n,BAD_CAST "version",BAD_CAST "1.0.0");
+  xmlNewProp(n,BAD_CAST "xml:lang",BAD_CAST "en");
+  char tmp[256];
+  char url[256];
+  memset(tmp,0,256);
+  memset(url,0,256);
+  maps* tmp_maps=getMaps(m,"main");
+  if(tmp_maps!=NULL){
+    map* tmpm=getMap(tmp_maps->content,"serverAddress");
+    map* tmpm1=getMap(tmp_maps->content,"tmpUrl");
+    if(tmpm!=NULL && tmpm1!=NULL){
+      sprintf(url,"%s/%s/%s_%i.xml",tmpm->value,tmpm1->value,service,pid);
+    }
+    if(tmpm!=NULL)
+      sprintf(tmp,"%s/",tmpm->value);
+  }
+
+  xmlNewProp(n,BAD_CAST "serviceInstance",BAD_CAST tmp);
+  if(status!=SERVICE_SUCCEEDED){
+    xmlNewProp(n,BAD_CAST "statusLocation",BAD_CAST url);
+  }
+
+  nc = xmlNewNode(ns, BAD_CAST "Process");
+  map* tmp2=getMap(serv->content,"processVersion");
+
+  if(tmp2!=NULL)
+    xmlNewNsProp(nc,ns,BAD_CAST "processVersion",BAD_CAST tmp2->value);
+  
+  printDescription(nc,ns_ows,serv->name,serv->content);
+  fflush(stderr);
+
+  xmlAddChild(n,nc);
+
+  nc = xmlNewNode(ns, BAD_CAST "Status");
+  const struct tm *tm;
+  size_t len;
+  time_t now;
+  char *tmp1;
+  
+  now = time ( NULL );
+  tm = localtime ( &now );
+
+  tmp1 = (char*)malloc((TIME_SIZE+1)*sizeof(char));
+
+  len = strftime ( tmp1, TIME_SIZE, "%Y-%m-%dT%I:%M:%SZ", tm );
+
+  switch(status){
+  case SERVICE_SUCCEEDED:
+    xmlNewProp(nc,BAD_CAST "creationTime",BAD_CAST tmp1);
+    nc1 = xmlNewNode(ns, BAD_CAST "ProcessSucceeded");
+    break;
+  case SERVICE_STARTED:
+    xmlNewProp(nc,BAD_CAST "creationTime",BAD_CAST tmp1);
+    nc1 = xmlNewNode(ns, BAD_CAST "ProcessStarted");
+    xmlNewProp(nc1,BAD_CAST "percentCompleted",BAD_CAST "NEED_SERVICE_ACCESS"); 
+    break;
+  case SERVICE_ACCEPTED:
+    xmlNewProp(nc,BAD_CAST "creationTime",BAD_CAST tmp1);
+    nc1 = xmlNewNode(ns, BAD_CAST "ProcessAccepted");
+    break;
+  case SERVICE_FAILED:
+    nc1 = xmlNewNode(ns, BAD_CAST "ProcessFailed");
+    break;
+  default :
+    printf("error code not know : %i\n",status);
+    exit(1);
+    break;
+  }
+  xmlAddChild(nc,nc1);
+  xmlAddChild(n,nc);
+  free(tmp1);
+
+#ifdef DEBUG
+  fprintf(stderr,"printProcessResponse 1 161\n");
+#endif
+
+  map* lineage=getMap(request,"lineage");
+  if(lineage!=NULL){
+    nc = xmlNewNode(ns, BAD_CAST "DataInputs");
+    int i;
+    maps* mcursor=inputs;
+    elements* scursor=serv->inputs;
+    while(mcursor!=NULL /*&& scursor!=NULL*/){
+      printIOType(doc,nc,ns,ns_ows,scursor,mcursor,"Input");
+      mcursor=mcursor->next;
+      //scursor=scursor->next;
+    }
+    xmlAddChild(n,nc);
+    
+#ifdef DEBUG
+    fprintf(stderr,"printProcessResponse 1 177\n");
+#endif
+
+    nc = xmlNewNode(ns, BAD_CAST "OutputDefinitions");
+    mcursor=outputs;
+    scursor=serv->outputs;
+    while(mcursor!=NULL /*&& scursor!=NULL*/){
+      printOutputDefinitions1(doc,nc,ns,ns_ows,scursor,mcursor,"Output");
+      mcursor=mcursor->next;
+      //scursor=scursor->next;
+    }
+    xmlAddChild(n,nc);
+  }
+#ifdef DEBUG
+  fprintf(stderr,"printProcessResponse 1 190\n");
+#endif
+
+  /**
+   * Display the process output only when requested !
+   */
+  if(status==SERVICE_SUCCEEDED){
+    nc = xmlNewNode(ns, BAD_CAST "ProcessOutputs");
+    maps* mcursor=outputs;
+    elements* scursor=serv->outputs;
+    while(mcursor!=NULL && scursor!=NULL){
+      printIOType(doc,nc,ns,ns_ows,scursor,mcursor,"Output");
+      mcursor=mcursor->next;
+      scursor=scursor->next;
+    }
+    xmlAddChild(n,nc);
+  }
+#ifdef DEBUG
+  fprintf(stderr,"printProcessResponse 1 202\n");
+#endif
+  xmlDocSetRootElement(doc, n);
+  printDocument(m,doc,pid);
+
+  xmlCleanupParser();
+  zooXmlCleanupNs();
+}
+
+
+void printDocument(maps* m, xmlDocPtr doc,int pid){
+  rewind(stdout);
+  char *encoding=getEncoding(m);
+  if(pid==getpid()){
+    printf("Content-Type: text/xml; charset=%s\r\nStatus: 200 OK\r\n\r\n",encoding);
+  }
+  fflush(stdout);
   xmlChar *xmlbuff;
   int buffersize;
   /*
-   * Dump the document to a buffer and print it
+   * Dump the document to a buffer and print it on stdout
    * for demonstration purposes.
    */
-  xmlDocDumpFormatMemory(doc, &xmlbuff, &buffersize, 1);
+  xmlDocDumpFormatMemoryEnc(doc, &xmlbuff, &buffersize, encoding, 1);
   printf((char *) xmlbuff);
-  
+  //fflush(stdout);
   /*
    * Free associated memory.
    */
   xmlFree(xmlbuff);
-  //xmlFreeDoc(doc);
-
-}
-//printGetCapabilitiesHeader
+  xmlFreeDoc(doc);
+  xmlCleanupParser();
+  zooXmlCleanupNs();
+}
 
 void printOutputDefinitions1(xmlDocPtr doc,xmlNodePtr nc,xmlNsPtr ns_wps,xmlNsPtr ns_ows,elements* e,maps* m,char* type){
@@ -1705,8 +1008,8 @@
   }
   while(tmp!=NULL){
-    if(strcmp(mtoupper(tmp->name),"MIMETYPE")==0
-       || strcmp(mtoupper(tmp->name),"ENCODING")==0
-       || strcmp(mtoupper(tmp->name),"SCHEMA")==0
-       || strcmp(mtoupper(tmp->name),"UOM")==0)
+    if(strncasecmp(tmp->name,"MIMETYPE",strlen(tmp->name))==0
+       || strncasecmp(tmp->name,"ENCODING",strlen(tmp->name))==0
+       || strncasecmp(tmp->name,"SCHEMA",strlen(tmp->name))==0
+       || strncasecmp(tmp->name,"UOM",strlen(tmp->name))==0)
     xmlNewProp(nc1,BAD_CAST tmp->name,BAD_CAST tmp->value);
     tmp=tmp->next;
@@ -1752,18 +1055,27 @@
 }
 
-void printIOType1(xmlDocPtr doc,xmlNodePtr nc,xmlNsPtr ns_wps,xmlNsPtr ns_ows,elements* e,maps* m,char* type){
+void printIOType(xmlDocPtr doc,xmlNodePtr nc,xmlNsPtr ns_wps,xmlNsPtr ns_ows,elements* e,maps* m,char* type){
   xmlNodePtr nc1,nc2,nc3;
   nc1=xmlNewNode(ns_wps, BAD_CAST type);
   map *tmp=e->content;
-#ifdef DEBUG
+  //#ifdef DEBUG
   dumpMap(tmp);
   dumpElements(e);
-#endif
+  //#endif
   nc2=xmlNewNode(ns_ows, BAD_CAST "Identifier");
-  xmlAddChild(nc2,xmlNewText(BAD_CAST m->name));
+  nc3=xmlNewText(BAD_CAST e->name);
+  xmlAddChild(nc2,nc3);
   xmlAddChild(nc1,nc2);
   xmlAddChild(nc,nc1);
+  // Extract Title required to be first element in the ZCFG file !
   nc2=xmlNewNode(ns_ows, BAD_CAST tmp->name);
-  xmlAddChild(nc2,xmlNewText(BAD_CAST tmp->value));
+  nc3=xmlNewText(BAD_CAST tmp->value);
+  xmlAddChild(nc2,nc3);  
+  xmlAddChild(nc1,nc2);
+  // Extract Abstract required to be second element in the ZCFG file !
+  tmp=tmp->next;
+  nc2=xmlNewNode(ns_ows, BAD_CAST tmp->name);
+  nc3=xmlNewText(BAD_CAST tmp->value);
+  xmlAddChild(nc2,nc3);  
   xmlAddChild(nc1,nc2);
   xmlAddChild(nc,nc1);
@@ -1773,90 +1085,67 @@
    * IO type Reference or full Data ?
    */
-#ifdef DEBUG
-  fprintf(stderr,"FORMAT %s %s\n",e->format,mtoupper(e->format));
-#endif
-  nc2=xmlNewNode(ns_wps, BAD_CAST "Data");
-  if(strcmp(mtoupper(e->format),"LITERALOUTPUT")==0)
-    nc3=xmlNewNode(ns_wps, BAD_CAST "LiteralData");
-  else
-    if(strcmp(mtoupper(e->format),"COMPLEXOUTPUT")==0)
-      nc3=xmlNewNode(ns_wps, BAD_CAST "ComplexData");
+  //#ifdef DEBUG
+  fprintf(stderr,"FORMAT %s %s\n",e->format,e->format);
+  //#endif
+  map *tmpMap=getMap(m->content,"Reference");
+  if(tmpMap==NULL){
+    nc2=xmlNewNode(ns_wps, BAD_CAST "Data");
+    if(strncasecmp(e->format,"LITERALOUTPUT",strlen(e->format))==0)
+      nc3=xmlNewNode(ns_wps, BAD_CAST "LiteralData");
     else
-      nc3=xmlNewNode(ns_wps, BAD_CAST e->format);
-  tmp=m->content;
-  while(tmp!=NULL){
-    if(strcmp(tmp->name,"value")!=0)
-      xmlNewProp(nc3,BAD_CAST tmp->name,BAD_CAST tmp->value);
-    tmp=tmp->next;
-    xmlAddChild(nc2,nc3);
-  }
-  tmp=getMap(e->defaults->content,"mimeType");
-  map* tmp1=getMap(m->content,"encoding");
-  map* tmp2=getMap(m->content,"mimeType");
-  map* toto=getMap(m->content,"value");
-  if((tmp1!=NULL && strncmp(tmp1->value,"base64",6)==0)
-     || (tmp2!=NULL && (strncmp(tmp2->value,"image/",6)==0
-			|| strncmp(tmp2->value,"application/",6)==0)) ){
-    map* rs=getMap(m->content,"size");
-    if(rs==NULL){
-      char tmp1[1024];
-      sprintf(tmp1,"%d",strlen(toto->value));
-      rs=createMap("z",tmp1);
-    }
-    xmlAddChild(nc3,xmlNewText(BAD_CAST base64((const unsigned char*)toto->value,atoi(rs->value))));
-  }
-  else if(tmp!=NULL){
-    if(strcmp(tmp->value,"text/js")==0)
-      xmlAddChild(nc3,xmlNewCDataBlock(doc,BAD_CAST toto->value,strlen(toto->value)));
+      if(strncasecmp(e->format,"COMPLEXOUTPUT",strlen(e->format))==0)
+	nc3=xmlNewNode(ns_wps, BAD_CAST "ComplexData");
+      else
+	nc3=xmlNewNode(ns_wps, BAD_CAST e->format);
+    tmp=m->content;
+    while(tmp!=NULL){
+      if(strncasecmp(tmp->name,"value",strlen(tmp->name))!=0 &&
+	 strncasecmp(tmp->name,"extension",strlen(tmp->name))!=0)
+	xmlNewProp(nc3,BAD_CAST tmp->name,BAD_CAST tmp->value);
+      tmp=tmp->next;
+      xmlAddChild(nc2,nc3);
+    }
+    tmp=getMap(e->defaults->content,"mimeType");
+    map* tmp1=getMap(m->content,"encoding");
+    map* tmp2=getMap(m->content,"mimeType");
+    map* toto=getMap(m->content,"value");
+    if((tmp1!=NULL && strncmp(tmp1->value,"base64",6)==0)
+       || (tmp2!=NULL && (strncmp(tmp2->value,"image/",6)==0
+			  || strncmp(tmp2->value,"application/",6)==0)) ){
+      map* rs=getMap(m->content,"size");
+      if(rs==NULL){
+	char tmp1[1024];
+	sprintf(tmp1,"%d",strlen(toto->value));
+	rs=createMap("z",tmp1);
+      }
+      xmlAddChild(nc3,xmlNewText(BAD_CAST base64((const unsigned char*)toto->value,atoi(rs->value))));
+    }
+    else if(tmp!=NULL){
+      if(strcmp(tmp->value,"text/js")==0)
+	xmlAddChild(nc3,xmlNewCDataBlock(doc,BAD_CAST toto->value,strlen(toto->value)));
+      else
+	xmlAddChild(nc3,xmlNewText(BAD_CAST toto->value));
+      xmlAddChild(nc2,nc3);
+    }
     else
       xmlAddChild(nc3,xmlNewText(BAD_CAST toto->value));
-    xmlAddChild(nc2,nc3);
-  }
-  else
-    xmlAddChild(nc3,xmlNewText(BAD_CAST toto->value));
-
-  xmlAddChild(nc1,nc2);
-  xmlAddChild(nc,nc1);
-
-}
-
-void printIOType(xmlDocPtr doc,xmlNodePtr nc,xmlNsPtr ns_wps,xmlNsPtr ns_ows,elements* e,map* m,char* type){
-  xmlNodePtr nc1,nc2,nc3;
-  nc1=xmlNewNode(ns_wps, BAD_CAST type);
-  map *tmp=e->content;
-  nc2=xmlNewNode(ns_ows, BAD_CAST "Identifier");
-  xmlAddChild(nc2,xmlNewText(BAD_CAST m->name));
-  xmlAddChild(nc1,nc2);
-  xmlAddChild(nc,nc1);
-  nc2=xmlNewNode(ns_ows, BAD_CAST tmp->name);
-  xmlAddChild(nc2,xmlNewText(BAD_CAST tmp->value));
-  xmlAddChild(nc1,nc2);
-  xmlAddChild(nc,nc1);
-  tmp=tmp->next;
-
-  /**
-   * IO type Reference or full Data ?
-   */
-#ifdef DEBUG
-  printf("FORMAT %s\n",e->format);
-#endif
-  nc2=xmlNewNode(ns_wps, BAD_CAST "Data");
-  nc3=xmlNewNode(ns_wps, BAD_CAST e->format);
-  tmp=e->defaults->content;
-  while(tmp!=NULL){
-    xmlNewProp(nc3,BAD_CAST tmp->name,BAD_CAST tmp->value);
-    tmp=tmp->next;
-    xmlAddChild(nc2,nc3);
-  }
-  tmp=getMap(e->defaults->content,"mimeType");
-  if(tmp!=NULL){
-    if(strcmp(tmp->value,"text/js")==0)
-      xmlAddChild(nc3,xmlNewCDataBlock(doc,BAD_CAST m->value,strlen(m->value)));
-    else
-      xmlAddChild(nc3,xmlNewText(BAD_CAST m->value));
-    xmlAddChild(nc2,nc3);
-  }
-  else
-    xmlAddChild(nc3,xmlNewText(BAD_CAST m->value));
+  }
+  else{
+    nc3=nc2=xmlNewNode(ns_wps, BAD_CAST "Reference");
+    xmlNewProp(nc3,BAD_CAST "href",BAD_CAST tmpMap->value);
+    tmp=m->content;
+    while(tmp!=NULL){
+      if(strncasecmp(tmp->name,"value",strlen(tmp->name))!=0 &&
+	 strncasecmp(tmp->name,"reference",strlen(tmp->name))!=0 &&
+	 strncasecmp(tmp->name,"extension",strlen(tmp->name))!=0 &&
+	 strncasecmp(tmp->name,"abstract",strlen(tmp->name))!=0 &&
+	 strncasecmp(tmp->name,"status",strlen(tmp->name))!=0 &&
+	 strncasecmp(tmp->name,"storeExecuteResponse",strlen(tmp->name))!=0 &&
+	 strncasecmp(tmp->name,"asReference",strlen(tmp->name))!=0)
+	xmlNewProp(nc3,BAD_CAST tmp->name,BAD_CAST tmp->value);
+      tmp=tmp->next;
+      xmlAddChild(nc2,nc3);
+    }
+  }
 
   xmlAddChild(nc1,nc2);
@@ -1884,49 +1173,55 @@
 }
 
+char* getEncoding(maps* m){
+  if(m!=NULL){
+    map* tmp=getMap(m->content,"encoding");
+    if(tmp!=NULL){
+      return tmp->value;
+    }
+    else
+      return "UTF-8";
+  }
+  else
+    return "UTF-8";  
+}
+
+char* getVersion(maps* m){
+  if(m!=NULL){
+    map* tmp=getMap(m->content,"version");
+    if(tmp!=NULL){
+      return tmp->value;
+    }
+    else
+      return "1.0.0";
+  }
+  else
+    return "1.0.0";
+}
+
 void printExceptionReportResponse(maps* m,map* s){
   
-  printf("Content-Type: text/xml; charset=utf-8\r\nStatus: 200 OK\r\n\r\n");  
   int buffersize;
   xmlDocPtr doc;
   xmlChar *xmlbuff;
-  xmlNsPtr ns=NULL;
-  xmlNodePtr nr = xmlNewNode(ns, BAD_CAST "root");
-  ns=xmlNewNs(nr,BAD_CAST "http://www.opengis.net/ows/1.1",BAD_CAST "ows");
-
-  maps* toto1=getMaps(m,"main");
+  xmlNsPtr ns,ns_ows,ns_xlink,ns_xsi;
+  xmlNodePtr n,nc,nc1,nc2;
+
   doc = xmlNewDoc(BAD_CAST "1.0");
-  if(toto1!=NULL){
-    map* tmp=getMap(toto1->content,"encoding");
-  //map* tmp=getMapFromMaps(m,"main","encoding");
-    if(tmp!=NULL){
-      doc->encoding = xmlCharStrdup(tmp->value);
-    }
-    else
-      doc->encoding = xmlCharStrdup("UTF-8");
-  }
-  else
-    doc->encoding = xmlCharStrdup ("UTF-8");
-
-  xmlNodePtr n = xmlNewNode(ns, BAD_CAST "ExceptionReport");  
-  xmlNsPtr ns_ows=xmlNewNs(n,BAD_CAST "http://www.opengis.net/ows/1.1",BAD_CAST "ows");
-  xmlNewNs(n,BAD_CAST "http://www.w3.org/1999/xlink",BAD_CAST "xlink");
-  xmlNewNs(n,BAD_CAST "http://www.w3.org/2001/XMLSchema-instance",BAD_CAST "xsi");
-  xmlNewProp(n,BAD_CAST "xsi:schemaLocation",BAD_CAST "http://www.opengis.net/ows/1.1 http://schemas.opengis.net/ows/1.1.0/owsExceptionReport.xsd");
-  xmlNewProp(n,BAD_CAST "xml:lan",BAD_CAST "en");
+  maps* tmpMap=getMaps(m,"main");
+  char *encoding=getEncoding(tmpMap);
+  printf("Content-Type: text/xml; charset=%s\r\nStatus: 200 OK\r\n\r\n",encoding);
+
+  ns=xmlNewNs(NULL,BAD_CAST "http://www.opengis.net/ows/1.1",BAD_CAST "ows");
+  n = xmlNewNode(ns, BAD_CAST "ExceptionReport");  
+  ns_ows=xmlNewNs(n,BAD_CAST "http://www.opengis.net/ows/1.1",BAD_CAST "ows");
+  ns_xlink=xmlNewNs(n,BAD_CAST "http://www.w3.org/1999/xlink",BAD_CAST "xlink");
+  ns_xsi=xmlNewNs(n,BAD_CAST "http://www.w3.org/2001/XMLSchema-instance",BAD_CAST "xsi");
+  xmlNewProp(n,BAD_CAST "xsi:schemaLocation",BAD_CAST "http://www.opengis.net/ows/1.1 http://schemas.opengis.net/ows/1.1/owsExceptionReport.xsd");
+  xmlNewProp(n,BAD_CAST "xml:lang",BAD_CAST "en");
   xmlNewProp(n,BAD_CAST "service",BAD_CAST "WPS");
 
-  if(toto1!=NULL){
-    map* tmp=getMap(toto1->content,"version");
-    if(tmp!=NULL){
-      xmlNewProp(n,BAD_CAST "version",BAD_CAST tmp->value);
-    }
-    else
-      xmlNewProp(n,BAD_CAST "version",BAD_CAST "1.0.0");
-  }
-  else
-    xmlNewProp(n,BAD_CAST "version",BAD_CAST "1.0.0");
-
-
-  xmlNodePtr nc = xmlNewNode(ns, BAD_CAST "Exception");  
+  xmlNewProp(n,BAD_CAST "version",BAD_CAST getVersion(tmpMap));
+
+  nc = xmlNewNode(ns, BAD_CAST "Exception");  
 
   map* tmp=getMap(s,"code");
